<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="DoxyPress 1.2.10"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Commanders: D:/Mes documents/Trusty/Arduino/Libraries/Commanders/src/ButtonsCommanderSwitchOnePin.cpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="doxypress.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by DoxyPress -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Commanders
   </div>
   <div id="projectbrief">Arduino buttons/bus library</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by DoxyPress 1.2.10 -->
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('ButtonsCommanderSwitchOnePin_8cpp_source.html','');});
</script>
<div id="doc-content">
<div class="header">
  <div class="headertitle">
<div class="title">ButtonsCommanderSwitchOnePin.cpp</div>  </div>
  <div class="clear-floats"></div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*************************************************************</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment">project: &lt;Commanders&gt;</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment">author: &lt;Thierry PARIS&gt;</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment">description: &lt;Switch button with one pin only with debounce.&gt;</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment">*************************************************************/</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;</div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="Commanders_8h.html">Commanders.h</a>&gt;</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="preprocessor">#ifndef NO_BUTTONSCOMMANDER</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor">#ifndef NO_BUTTONSCOMMANDERSWITCH</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;</div><div class="line"><a name="l00011"></a><span class="lineno"><a class="line" href="classButtonsCommanderSwitchOnePin.html#a8c43c44b9408bb887107e09407f2ea5c">   11</a></span>&#160;<a class="code" href="classButtonsCommanderSwitchOnePin.html#a8c43c44b9408bb887107e09407f2ea5c">ButtonsCommanderSwitchOnePin::ButtonsCommanderSwitchOnePin</a>() : <a class="code" href="classButtonsCommanderButton.html">ButtonsCommanderButton</a>(<a class="code" href="Events_8h.html#a48ad4dd16b8e22f2c8bc92b154479e92">UNDEFINED_ID</a>)</div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;{</div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;    this-&gt;debounceDelay = 50;</div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;    this-&gt;lastSelectedPin = DP_INVALID;</div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;}</div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;</div><div class="line"><a name="l00017"></a><span class="lineno"><a class="line" href="classButtonsCommanderSwitchOnePin.html#af30fa302f6149e466ec241ee5b9c6fba">   17</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="classButtonsCommanderSwitchOnePin.html#af30fa302f6149e466ec241ee5b9c6fba">ButtonsCommanderSwitchOnePin::begin</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> inId, <span class="keywordtype">int</span> inPin)</div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;{</div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;    this-&gt;Pin = Arduino_to_GPIO_pin(inPin);</div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;    this-&gt;<a class="code" href="classButtonsCommanderButton.html#a3b40667770ab04694a2ea85f11aebfe0">Id</a> = inId;</div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;</div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;    pinMode2f(this-&gt;Pin, INPUT_PULLUP);</div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;}</div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;</div><div class="line"><a name="l00025"></a><span class="lineno"><a class="line" href="classButtonsCommanderSwitchOnePin.html#af4a18cad9ddbb3f59ebe3e83e446a377">   25</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="classButtonsCommanderSwitchOnePin.html#af4a18cad9ddbb3f59ebe3e83e446a377">ButtonsCommanderSwitchOnePin::beforeFirstLoop</a>()</div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;{</div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;    <span class="keywordflow">if</span> (this-&gt;Pin != DP_INVALID)</div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;    {</div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;        <span class="comment">// Initialize first switch state at start</span></div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;        this-&gt;lastButtonState = digitalRead2f(this-&gt;Pin);</div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;</div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;        <a class="code" href="classCommanders.html#a7adbe54da67e90e0d39b58d69ac3add0">Commanders::RaiseEvent</a>(this-&gt;<a class="code" href="classButtonsCommanderButton.html#a3b40667770ab04694a2ea85f11aebfe0">Id</a>, <a class="code" href="Events_8h.html#a36239a7eea6194f04e73e80d7419490caebdb45ee96bd05e90e9e633c114e9cba">COMMANDERS_EVENT_MOVE</a>, this-&gt;lastButtonState == LOW ? <a class="code" href="Events_8h.html#a347ec2e7ad5bc98b641a887ce34cc2baa1675bf6790ab941818b2623b710d9826">COMMANDERS_MOVE_ON</a> : <a class="code" href="Events_8h.html#a347ec2e7ad5bc98b641a887ce34cc2baa72085934c5621169aa9f5e3f7a32a7c6">COMMANDERS_MOVE_OFF</a>);</div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;        <span class="keywordflow">if</span> (this-&gt;lastButtonState == LOW)</div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;            this-&gt;lastSelectedPin = this-&gt;Pin;</div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;    }</div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;}</div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;</div><div class="line"><a name="l00038"></a><span class="lineno"><a class="line" href="classButtonsCommanderSwitchOnePin.html#a13b39217d1b55574422ea1d8bded0f62">   38</a></span>&#160;<span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> <a class="code" href="classButtonsCommanderSwitchOnePin.html#a13b39217d1b55574422ea1d8bded0f62">ButtonsCommanderSwitchOnePin::loop</a>()</div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;{ </div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;    <span class="keywordflow">return</span> <a class="code" href="classButtonsCommanderSwitch.html#ab4ff8f2eead168e08c2f385022c06a4a">ButtonsCommanderSwitch::loopOnePin</a>(this-&gt;Pin, this-&gt;<a class="code" href="classButtonsCommanderButton.html#a3b40667770ab04694a2ea85f11aebfe0">Id</a>, this-&gt;lastSelectedPin == DP_INVALID ? <a class="code" href="Events_8h.html#a48ad4dd16b8e22f2c8bc92b154479e92">UNDEFINED_ID</a> : this-&gt;<a class="code" href="classButtonsCommanderButton.html#a3b40667770ab04694a2ea85f11aebfe0">Id</a>,</div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;        &amp;this-&gt;debounceDelay, &amp;this-&gt;lastSelectedPin,</div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;        &amp;this-&gt;lastButtonState, &amp;this-&gt;lastDebounceTime);</div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;}</div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;</div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;<span class="preprocessor">#ifdef COMMANDERS_PRINT_COMMANDERS</span></div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;<span class="keywordtype">void</span> ButtonsCommanderSwitchOnePin::printCommander()</div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;{</div><div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;    Serial.print(F(<span class="stringliteral">&quot;    SwitchOnePin        Pin: &quot;</span>));</div><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;    Serial.print(GPIO_to_Arduino_pin(this-&gt;Pin));</div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;    Serial.print(F(<span class="stringliteral">&quot; / Id: &quot;</span>));</div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;    Serial.print(this-&gt;<a class="code" href="classButtonsCommanderButton.html#a3b40667770ab04694a2ea85f11aebfe0">Id</a>);</div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;    Serial.println(F(<span class="stringliteral">&quot;&quot;</span>));</div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;}</div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;<span class="preprocessor">#endif</span></div><div class="ttc" id="classButtonsCommanderSwitch_html_ab4ff8f2eead168e08c2f385022c06a4a"><div class="ttname"><a href="classButtonsCommanderSwitch.html#ab4ff8f2eead168e08c2f385022c06a4a">ButtonsCommanderSwitch::loopOnePin</a></div><div class="ttdeci">static unsigned long loopOnePin(GPIO_pin_t inPin, unsigned long inId, unsigned long inPreviousId, unsigned long *apDebounceDelay, GPIO_pin_t *apLastSelectedPin, int *apLastButtonState, unsigned long *apLastDebounceTime, bool inSendEvent = true)</div><div class="ttdef"><b>Definition:</b> <a href="ButtonsCommanderSwitch_8cpp_source.html#l00072">ButtonsCommanderSwitch.cpp:72</a></div></div>
<div class="ttc" id="classButtonsCommanderSwitchOnePin_html_a13b39217d1b55574422ea1d8bded0f62"><div class="ttname"><a href="classButtonsCommanderSwitchOnePin.html#a13b39217d1b55574422ea1d8bded0f62">ButtonsCommanderSwitchOnePin::loop</a></div><div class="ttdeci">unsigned long loop()</div><div class="ttdef"><b>Definition:</b> <a href="ButtonsCommanderSwitchOnePin_8cpp_source.html#l00038">ButtonsCommanderSwitchOnePin.cpp:38</a></div></div>
<div class="ttc" id="Events_8h_html_a347ec2e7ad5bc98b641a887ce34cc2baa1675bf6790ab941818b2623b710d9826"><div class="ttname"><a href="Events_8h.html#a347ec2e7ad5bc98b641a887ce34cc2baa1675bf6790ab941818b2623b710d9826">COMMANDERS_MOVE_ON</a></div><div class="ttdef"><b>Definition:</b> <a href="Events_8h_source.html#l00020">Events.h:20</a></div></div>
<div class="ttc" id="Events_8h_html_a36239a7eea6194f04e73e80d7419490caebdb45ee96bd05e90e9e633c114e9cba"><div class="ttname"><a href="Events_8h.html#a36239a7eea6194f04e73e80d7419490caebdb45ee96bd05e90e9e633c114e9cba">COMMANDERS_EVENT_MOVE</a></div><div class="ttdef"><b>Definition:</b> <a href="Events_8h_source.html#l00029">Events.h:29</a></div></div>
<div class="ttc" id="classCommanders_html_a7adbe54da67e90e0d39b58d69ac3add0"><div class="ttname"><a href="classCommanders.html#a7adbe54da67e90e0d39b58d69ac3add0">Commanders::RaiseEvent</a></div><div class="ttdeci">static unsigned long RaiseEvent(unsigned long inId, COMMANDERS_EVENT_TYPE inEvent = COMMANDERS_EVENT_MOVEPOSITIONID, int inData = 0)</div><div class="ttdef"><b>Definition:</b> <a href="Commanders_8cpp_source.html#l00027">Commanders.cpp:27</a></div></div>
<div class="ttc" id="classButtonsCommanderSwitchOnePin_html_af4a18cad9ddbb3f59ebe3e83e446a377"><div class="ttname"><a href="classButtonsCommanderSwitchOnePin.html#af4a18cad9ddbb3f59ebe3e83e446a377">ButtonsCommanderSwitchOnePin::beforeFirstLoop</a></div><div class="ttdeci">void beforeFirstLoop()</div><div class="ttdef"><b>Definition:</b> <a href="ButtonsCommanderSwitchOnePin_8cpp_source.html#l00025">ButtonsCommanderSwitchOnePin.cpp:25</a></div></div>
<div class="ttc" id="Events_8h_html_a347ec2e7ad5bc98b641a887ce34cc2baa72085934c5621169aa9f5e3f7a32a7c6"><div class="ttname"><a href="Events_8h.html#a347ec2e7ad5bc98b641a887ce34cc2baa72085934c5621169aa9f5e3f7a32a7c6">COMMANDERS_MOVE_OFF</a></div><div class="ttdef"><b>Definition:</b> <a href="Events_8h_source.html#l00021">Events.h:21</a></div></div>
<div class="ttc" id="classButtonsCommanderSwitchOnePin_html_af30fa302f6149e466ec241ee5b9c6fba"><div class="ttname"><a href="classButtonsCommanderSwitchOnePin.html#af30fa302f6149e466ec241ee5b9c6fba">ButtonsCommanderSwitchOnePin::begin</a></div><div class="ttdeci">void begin(unsigned long inId, int inPin)</div><div class="ttdef"><b>Definition:</b> <a href="ButtonsCommanderSwitchOnePin_8cpp_source.html#l00017">ButtonsCommanderSwitchOnePin.cpp:17</a></div></div>
<div class="ttc" id="Events_8h_html_a48ad4dd16b8e22f2c8bc92b154479e92"><div class="ttname"><a href="Events_8h.html#a48ad4dd16b8e22f2c8bc92b154479e92">UNDEFINED_ID</a></div><div class="ttdeci">#define UNDEFINED_ID</div><div class="ttdef"><b>Definition:</b> <a href="Events_8h_source.html#l00038">Events.h:38</a></div></div>
<div class="ttc" id="classButtonsCommanderButton_html_a3b40667770ab04694a2ea85f11aebfe0"><div class="ttname"><a href="classButtonsCommanderButton.html#a3b40667770ab04694a2ea85f11aebfe0">ButtonsCommanderButton::Id</a></div><div class="ttdeci">unsigned long Id</div><div class="ttdef"><b>Definition:</b> <a href="ButtonsCommanderButton_8hpp_source.html#l00019">ButtonsCommanderButton.hpp:19</a></div></div>
<div class="ttc" id="classButtonsCommanderButton_html"><div class="ttname"><a href="classButtonsCommanderButton.html">ButtonsCommanderButton</a></div><div class="ttdef"><b>Definition:</b> <a href="ButtonsCommanderButton_8hpp_source.html#l00015">ButtonsCommanderButton.hpp:15</a></div></div>
<div class="ttc" id="classButtonsCommanderSwitchOnePin_html_a8c43c44b9408bb887107e09407f2ea5c"><div class="ttname"><a href="classButtonsCommanderSwitchOnePin.html#a8c43c44b9408bb887107e09407f2ea5c">ButtonsCommanderSwitchOnePin::ButtonsCommanderSwitchOnePin</a></div><div class="ttdeci">ButtonsCommanderSwitchOnePin()</div><div class="ttdef"><b>Definition:</b> <a href="ButtonsCommanderSwitchOnePin_8cpp_source.html#l00011">ButtonsCommanderSwitchOnePin.cpp:11</a></div></div>
<div class="ttc" id="Commanders_8h_html"><div class="ttname"><a href="Commanders_8h.html">Commanders.h</a></div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- Generated by DoxyPress 1.2.10 -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_d41d8cd98f00b204e9800998ecf8427e.html">src</a></li><li class="navelem"><b>ButtonsCommanderSwitchOnePin.cpp</b></li>
    <li class="footer">Generated on mer. oct. 18 2017 17:55:02 for Commanders &nbsp; by
    <a href="http://www.copperspice.com/documentation-doxypress.html">
    <img class="footer" src="doxypress.png" alt="DoxyPress"/></a> 1.2.10 </li>
  </ul>
</div>
</body>
</html>
